*                                                                      *
*=== mgdraw ===========================================================*
*                                                                      *
      SUBROUTINE MGDRAW ( ICODE, MREG )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'

      INCLUDE '(FLKMAT)'
      INCLUDE '(OPPHST)'
      INCLUDE 'fibr.inc'
*
*----------------------------------------------------------------------*
*                                                                      *
*     MaGnetic field trajectory DRAWing: actually this entry manages   *
*                                        all trajectory dumping for    *
*                                        drawing                       *
*                                                                      *
*     Created on   01 march 1990   by        Alfredo Ferrari           *
*                                              INFN - Milan            *
*     last change  05-may-06       by        Alfredo Ferrari           *
*                                              INFN - Milan            *
*                                                                      *
*----------------------------------------------------------------------*
*
      INCLUDE '(CASLIM)'
      INCLUDE '(COMPUT)'
      INCLUDE '(SOURCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(GENSTK)'
      INCLUDE '(MGDDCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(QUEMGD)'
      INCLUDE '(SUMCOU)'
      INCLUDE '(TRACKR)'
*
      DIMENSION DTQUEN ( MXTRCK, MAXQMG )
*
      CHARACTER*20 FILNAM
      LOGICAL LFCOPE
      SAVE LFCOPE
      DATA LFCOPE / .FALSE. /
*
*----------------------------------------------------------------------*
*                                                                      *
*     Icode = 1: call from Kaskad                                      *
*     Icode = 2: call from Emfsco                                      *
*     Icode = 3: call from Kasneu                                      *
*     Icode = 4: call from Kashea                                      *
*     Icode = 5: call from Kasoph                                      *
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
      IF ( .NOT. LFCOPE ) THEN
         LFCOPE = .TRUE.
         IF ( KOMPUT .EQ. 2 ) THEN
            FILNAM = '/'//CFDRAW(1:8)//' DUMP A'
         ELSE
            FILNAM = CFDRAW
         END IF
c         WRITE(*,*) 'TRAJECTORY OPEN!'
c         WRITE(*,'(A)') 'FILNAM = ',FILNAM
         OPEN ( UNIT = IODRAW, FILE = FILNAM, STATUS = 'NEW', FORM =
     &          'UNFORMATTED' )
      END IF
C
C     Write trajectories of optical photons
C
      IF(JTRACK .EQ. -1) THEN
         WRITE (IODRAW) NTRACK, MTRACK, JTRACK, SNGL (ETRACK),
     &        SNGL (WTRACK)
         WRITE (IODRAW) ( SNGL (XTRACK (I)), SNGL (YTRACK (I)),
     &        SNGL (ZTRACK (I)), I = 0, NTRACK ),
     &        ( SNGL (DTRACK (I)), I = 1,MTRACK ),
     &        SNGL (CTRACK)
         WRITE(IODRAW) SNGL(CXTRCK),SNGL(CYTRCK),SNGL(CZTRCK)
      ENDIF
      RETURN
*
*======================================================================*
*                                                                      *
*     Boundary-(X)crossing DRAWing:                                    *
*                                                                      *
*     Icode = 1x: call from Kaskad                                     *
*             19: boundary crossing                                    *
*     Icode = 2x: call from Emfsco                                     *
*             29: boundary crossing                                    *
*     Icode = 3x: call from Kasneu                                     *
*             39: boundary crossing                                    *
*     Icode = 4x: call from Kashea                                     *
*             49: boundary crossing                                    *
*     Icode = 5x: call from Kasoph                                     *
*             59: boundary crossing                                    *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY BXDRAW ( ICODE, MREG, NEWREG, XSCO, YSCO, ZSCO )

c     Sono i mteriali di cui è composto il mezzo n e quello n+1
      CMED = MEDFLK(MREG,2)
      NMED = MEDFLK(NEWREG,2)


c     Conto i BDX dei fotoni verdi.
      IF ( ACT .EQ. 1 ) THEN

c        WRITE(*,*)"Cx: ", Cxtrck,"    OCx: ", txopph(1),
c     &            "    evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)"Cy: ", Cytrck,"    OCy: ", tyopph(1),
c     &            "    evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)"Cz: ", Cztrck,"    OCz: ", tzopph(1),
c     &            "    evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)"ICODE: ", Icode
c        WRITE(*,*)" "



c        --------------------------------------------------
        IF ( CMED .EQ. 30 .AND. NMED .EQ. 27 ) THEN
          
          CCLPM = CCLPM + 1
         
        ELSEIF ( CMED .EQ. 29 .AND. NMED .EQ. 27 ) THEN

          CCOPM = CCOPM + 1

        ENDIF

c        -----------fotoni verso l'aria nell'angolo limite--------------

	IF ( MREG .GE. 8 .AND. MREG .LE. 71 .AND. NEWREG .EQ. 3 
     &            .AND. Cztrck .LE. -0.931055 ) THEN

          CFIBAI = CFIBAI + 1

	ELSEIF ( MREG .GE. 73 .AND. MREG .LE. 136 .AND. NEWREG .EQ. 3 
     &                .AND. Cxtrck .LE. -0.931055 ) THEN

          CFIBAI = CFIBAI + 1

        ENDIF 



c	IF ( MREG .GE. 8 .AND. MREG .LE. 71
c     &            .AND. NEWREG .GE. 137 .AND. NEWREG .LE. 168 
c     &            .AND. Cztrck .LE. 0.931055 ) THEN
c
c        WRITE(*,*)"ESCLUSO ORIZ.: x: ", XFIB," y: ", YFIB," z: ",ZFIB
c        WRITE(*,*)"Cx: ", Cxtrck," OCx: ", txopph(1),
c     &            " evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)"Cy: ", Cytrck," OCy: ", tyopph(1)," evt: ",
c     &            " evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)"Cz: ", Cztrck," OCz: ", tzopph(1)," evt: ",
c     &            " evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)" "
c
c	ELSEIF ( MREG .GE. 73 .AND. MREG .LE. 136 
c     &            .AND. NEWREG .GE. 169 .AND. NEWREG .LE. 200 
c     &            .AND. Cxtrck .LE. 0.931055 ) THEN
c
c        WRITE(*,*)"ESCLUSO VERT.: x: ", XFIB," y: ", YFIB," z: ",ZFIB
c        WRITE(*,*)"Cx: ", Cxtrck," OCx: ", txopph(1),
c     &            " evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)"Cy: ", Cytrck," OCy: ", tyopph(1)," evt: ",
c     &            " evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)"Cz: ", Cztrck," OCz: ", tzopph(1)," evt: ",
c     &            " evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)" "
c
c	ENDIF


c --------------fotoni verso i pm nell'angolo limite---------------  

	IF ( MREG .GE. 8 .AND. MREG .LE. 71
     &            .AND. NEWREG .GE. 137 .AND. NEWREG .LE. 168 
     &            .AND. Cztrck .GE. 0.931055 ) THEN

c        WRITE(*,*)"PRESO ORIZ.: x: ", XFIB," y: ", YFIB," z: ",ZFIB
c        WRITE(*,*)"Cx: ", Cxtrck," OCx: ", txopph(1),
c     &            " evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)"Cy: ", Cytrck," OCy: ", tyopph(1)," evt: ",
c     &            " evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)"Cz: ", Cztrck," OCz: ", tzopph(1)," evt: ",
c     &            " evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)" "

           CPM = CPM + 1
           CPMO = CPMO + 1

c     Conto i BDX orizzontali (dal core al pm)
           IF ( NEWREG .EQ. 137 ) THEN 
              PMO1 = PMO1 + 1  
           ELSEIF ( NEWREG .EQ. 138 ) THEN 
              PMO2 = PMO2 + 1
           ELSEIF ( NEWREG .EQ. 139 ) THEN 
              PMO3 = PMO3 + 1
           ELSEIF ( NEWREG .EQ. 140 ) THEN 
              PMO4 = PMO4 + 1
           ELSEIF ( NEWREG .EQ. 141 ) THEN 
              PMO5 = PMO5 + 1
           ELSEIF ( NEWREG .EQ. 142 ) THEN 
              PMO6 = PMO6 + 1
           ELSEIF ( NEWREG .EQ. 143 ) THEN 
              PMO7 = PMO7 + 1
           ELSEIF ( NEWREG .EQ. 144 ) THEN 
              PMO8 = PMO8 + 1
           ELSEIF ( NEWREG .EQ. 145 ) THEN 
              PMO9 = PMO9 + 1
           ELSEIF ( NEWREG .EQ. 146 ) THEN 
              PMO10 = PMO10 + 1
           ELSEIF ( NEWREG .EQ. 147 ) THEN 
              PMO11 = PMO11 + 1
           ELSEIF ( NEWREG .EQ. 148 ) THEN 
              PMO12 = PMO12 + 1
           ELSEIF ( NEWREG .EQ. 149 ) THEN 
              PMO13 = PMO13 + 1
           ELSEIF ( NEWREG .EQ. 150 ) THEN 
              PMO14 = PMO14 + 1
           ELSEIF ( NEWREG .EQ. 151 ) THEN 
              PMO15 = PMO15 + 1
           ELSEIF ( NEWREG .EQ. 152 ) THEN 
              PMO16 = PMO16 + 1
           ELSEIF ( NEWREG .EQ. 153 ) THEN 
              PMO17 = PMO17 + 1
           ELSEIF ( NEWREG .EQ. 154 ) THEN 
              PMO18 = PMO18 + 1
           ELSEIF ( NEWREG .EQ. 155 ) THEN 
              PMO19 = PMO19 + 1
           ELSEIF ( NEWREG .EQ. 156 ) THEN 
              PMO20 = PMO20 + 1
           ELSEIF ( NEWREG .EQ. 157 ) THEN 
              PMO21 = PMO21 + 1
           ELSEIF ( NEWREG .EQ. 158 ) THEN 
              PMO22 = PMO22 + 1
           ELSEIF ( NEWREG .EQ. 159 ) THEN 
              PMO23 = PMO23 + 1
           ELSEIF ( NEWREG .EQ. 160 ) THEN 
              PMO24 = PMO24 + 1
           ELSEIF ( NEWREG .EQ. 161 ) THEN 
              PMO25 = PMO25 + 1
           ELSEIF ( NEWREG .EQ. 162 ) THEN 
              PMO26 = PMO26 + 1
           ELSEIF ( NEWREG .EQ. 163 ) THEN 
              PMO27 = PMO27 + 1
           ELSEIF ( NEWREG .EQ. 164 ) THEN 
              PMO28 = PMO28 + 1
           ELSEIF ( NEWREG .EQ. 165 ) THEN 
              PMO29 = PMO29 + 1
           ELSEIF ( NEWREG .EQ. 166 ) THEN 
              PMO30 = PMO30 + 1
           ELSEIF ( NEWREG .EQ. 167 ) THEN 
              PMO31 = PMO31 + 1
           ELSEIF ( NEWREG .EQ. 168 ) THEN 
              PMO32 = PMO32 + 1
           ENDIF
	 ENDIF

	IF ( MREG .GE. 73 .AND. MREG .LE. 136 
     &            .AND. NEWREG .GE. 169 .AND. NEWREG .LE. 200 
     &            .AND. Cxtrck .GE. 0.931055 ) THEN

           CPM = CPM + 1
           CPMV = CPMV + 1

c        WRITE(*,*)"PRESO VERT.: x: ", XFIB," y: ", YFIB," z: ",ZFIB
c        WRITE(*,*)"Cx: ", Cxtrck," OCx: ", txopph(1),
c     &            " evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)"Cy: ", Cytrck," OCy: ", tyopph(1)," evt: ",
c     &            " evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)"Cz: ", Cztrck," OCz: ", tzopph(1)," evt: ",
c     &            " evt: ", NCASE," da: ", CMED," a: ", NMED 
c        WRITE(*,*)" "


c     Conto i BDX verticali (dal core al pm)
           IF ( NEWREG .EQ. 169 ) THEN 
              PMV1 = PMV1 + 1
           ELSEIF ( NEWREG .EQ. 170 ) THEN 
              PMV2 = PMV2 + 1
           ELSEIF ( NEWREG .EQ. 171 ) THEN 
              PMV3 = PMV3 + 1
           ELSEIF ( NEWREG .EQ. 172 ) THEN 
              PMV4 = PMV4 + 1
           ELSEIF ( NEWREG .EQ. 173 ) THEN 
              PMV5 = PMV5 + 1
           ELSEIF ( NEWREG .EQ. 174 ) THEN 
              PMV6 = PMV6 + 1
           ELSEIF ( NEWREG .EQ. 175 ) THEN 
              PMV7 = PMV7 + 1
           ELSEIF ( NEWREG .EQ. 176 ) THEN 
              PMV8 = PMV8 + 1
           ELSEIF ( NEWREG .EQ. 177 ) THEN 
              PMV9 = PMV9 + 1
           ELSEIF ( NEWREG .EQ. 178 ) THEN 
              PMV10 = PMV10 + 1
           ELSEIF ( NEWREG .EQ. 179 ) THEN 
              PMV11 = PMV11 + 1
           ELSEIF ( NEWREG .EQ. 180 ) THEN 
              PMV12 = PMV12 + 1
           ELSEIF ( NEWREG .EQ. 181 ) THEN 
              PMV13 = PMV13 + 1
           ELSEIF ( NEWREG .EQ. 182 ) THEN 
              PMV14 = PMV14 + 1
           ELSEIF ( NEWREG .EQ. 183 ) THEN 
              PMV15 = PMV15 + 1
           ELSEIF ( NEWREG .EQ. 184 ) THEN 
              PMV16 = PMV16 + 1
           ELSEIF ( NEWREG .EQ. 185 ) THEN 
              PMV17 = PMV17 + 1
           ELSEIF ( NEWREG .EQ. 186 ) THEN 
              PMV18 = PMV18 + 1
           ELSEIF ( NEWREG .EQ. 187 ) THEN 
              PMV19 = PMV19 + 1
           ELSEIF ( NEWREG .EQ. 188 ) THEN 
              PMV20 = PMV20 + 1
           ELSEIF ( NEWREG .EQ. 189 ) THEN 
              PMV21 = PMV21 + 1
           ELSEIF ( NEWREG .EQ. 190 ) THEN 
              PMV22 = PMV22 + 1
           ELSEIF ( NEWREG .EQ. 191 ) THEN 
              PMV23 = PMV23 + 1
           ELSEIF ( NEWREG .EQ. 192 ) THEN 
              PMV24 = PMV24 + 1
           ELSEIF ( NEWREG .EQ. 193 ) THEN 
              PMV25 = PMV25 + 1
           ELSEIF ( NEWREG .EQ. 194 ) THEN 
              PMV26 = PMV26 + 1
           ELSEIF ( NEWREG .EQ. 195 ) THEN 
              PMV27 = PMV27 + 1
           ELSEIF ( NEWREG .EQ. 196 ) THEN 
              PMV28 = PMV28 + 1
           ELSEIF ( NEWREG .EQ. 197 ) THEN 
              PMV29 = PMV29 + 1
           ELSEIF ( NEWREG .EQ. 198 ) THEN 
              PMV30 = PMV30 + 1
           ELSEIF ( NEWREG .EQ. 199 ) THEN 
              PMV31 = PMV31 + 1
           ELSEIF ( NEWREG .EQ. 200 ) THEN 
              PMV32 = PMV32 + 1
           ENDIF
         ENDIF

      ENDIF
      
 
      RETURN
*
*======================================================================*
*                                                                      *
*     Event End DRAWing:                                               *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY EEDRAW ( ICODE )
      RETURN
*
*======================================================================*
*                                                                      *
*     ENergy deposition DRAWing:                                       *
*                                                                      *
*     Icode = 1x: call from Kaskad                                     *
*             10: elastic interaction recoil                           *
*             11: inelastic interaction recoil                         *
*             12: stopping particle                                    *
*             13: pseudo-neutron deposition                            *
*             14: escape                                               *
*             15: time kill                                            *
*     Icode = 2x: call from Emfsco                                     *
*             20: local energy deposition (i.e. photoelectric)         *
*             21: below threshold, iarg=1                              *
*             22: below threshold, iarg=2                              *
*             23: escape                                               *
*             24: time kill                                            *
*     Icode = 3x: call from Kasneu                                     *
*             30: target recoil                                        *
*             31: below threshold                                      *
*             32: escape                                               *
*             33: time kill                                            *
*     Icode = 4x: call from Kashea                                     *
*             40: escape                                               *
*             41: time kill                                            *
*             42: delta ray stack overflow                             *
*     Icode = 5x: call from Kasoph                                     *
*             50: optical photon absorption                            *
*             51: escape                                               *
*             52: time kill                                            *
*                                                                      *
*======================================================================*
*                                                                      *
      ENTRY ENDRAW ( ICODE, MREG, RULL, XSCO, YSCO, ZSCO )

c     Conto i decadimenti dei fotoni blu prima di tutto nel il PS
c     e poi nel PMMA e nell'Al indifferentemente fra le fibre 
c     sopra e sotto.
      IF ( ACT .EQ. 0 .AND. MEDFLK(MREG,2) .EQ. 29 ) THEN

c        Quando il fotone n, blu, decade faccio in modo che il
c        fotone n+1 sia verde.
         ACT = 1
         XFIB = XSCO
         YFIB = YSCO
         ZFIB = ZSCO
         RFIB = MREG
           
         CPS = CPS + 1

    
      ELSEIF ( ACT .EQ. 0 .AND. MEDFLK(MREG,2) .EQ. 30 ) THEN

         CPMMA = CPMMA + 1

      ELSEIF ( ACT .EQ. 0 .AND. MEDFLK(MREG,2) .EQ. 10 ) THEN
      
         CAL = CAL + 1

      ELSEIF ( ACT .EQ. 1 .AND. SOR .EQ. 0 ) THEN

c        Quando il fotone n, verde, decade faccio in modo che il
c        fotone n+1 sia blu. Se la variabile SOR è 0 la sorgente
c        di eventi è posizionata al centro dello scintillatore,
c        se SOR è 1 gli eventi vengono generati casualmente nello
c        scintillatore.
 
         ACT = 0
         XFIB = XZER
         YFIB = YZER
         ZFIB = ZZER

c	WRITE(*,*)"ENDRAW: ",MEDFLK(MREG,2)

      ELSEIF ( ACT .EQ. 1 .AND. SOR .EQ. 1 ) THEN

         ACT = 0      
         XFIB = -1.58D+00 + 3.16D+00 * FLRNDM(XDUMMY) 
         YFIB = -0.48D+00 + 0.96D+00 * FLRNDM(XDUMMY) 
         ZFIB = -1.58D+00 + 3.16D+00 * FLRNDM(XDUMMY)  

      ENDIF

      RETURN
*
*======================================================================*
*                                                                      *
*     SOurce particle DRAWing:                                         *
*                                                                      *
*======================================================================*
*
      ENTRY SODRAW
*  |
*  +-------------------------------------------------------------------*
      RETURN
*
*======================================================================*
*                                                                      *
*     USer dependent DRAWing:                                          *
*                                                                      *
*     Icode = 10x: call from Kaskad                                    *
*             100: elastic   interaction secondaries                   *
*             101: inelastic interaction secondaries                   *
*             102: particle decay  secondaries                         *
*             103: delta ray  generation secondaries                   *
*             104: pair production secondaries                         *
*             105: bremsstrahlung  secondaries                         *
*             110: decay products                                      *
*     Icode = 20x: call from Emfsco                                    *
*             208: bremsstrahlung secondaries                          *
*             210: Moller secondaries                                  *
*             212: Bhabha secondaries                                  *
*             214: in-flight annihilation secondaries                  *
*             215: annihilation at rest   secondaries                  *
*             217: pair production        secondaries                  *
*             219: Compton scattering     secondaries                  *
*             221: photoelectric          secondaries                  *
*             225: Rayleigh scattering    secondaries                  *
*     Icode = 30x: call from Kasneu                                    *
*             300: interaction secondaries                             *
*     Icode = 40x: call from Kashea                                    *
*             400: delta ray  generation secondaries                   *
*  For all interactions secondaries are put on GENSTK common (kp=1,np) *
*  but for KASHEA delta ray generation where only the secondary elec-  *
*  tron is present and stacked on FLKSTK common for kp=npflka          *
*                                                                      *
*======================================================================*
*
      ENTRY USDRAW ( ICODE, MREG, XSCO, YSCO, ZSCO )
* No output by default:
      RETURN
*=== End of subroutine Mgdraw ==========================================*
      END

