*$ CREATE USRINI.FOR
*COPY USRINI
*
*=== usrini ===========================================================*
*
      SUBROUTINE USRINI ( WHAT, SDUM )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'

      INCLUDE '(FLKMAT)'
      INCLUDE 'fibr.inc'
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1991-2005      by    Alfredo Ferrari & Paola Sala  *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     USeR INItialization: this routine is called every time the       *
*                          USRICALL card is found in the input stream  *
*                                                                      *
*                                                                      *
*     Created on 01 january 1991   by    Alfredo Ferrari & Paola Sala  *
*                                                   Infn - Milan       *
*                                                                      *
*     Last change on 20-mar-05     by    Alfredo Ferrari               *
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*
      DIMENSION WHAT (6)
      CHARACTER SDUM*8
*
*  Don't change the following line:
      LUSRIN = .TRUE.
* *** Write from here on *** *


*
*----------------------------------------------------------------------*
*                                                                      *
*     MATERIALE: 1 - ALLUMINIO                           (10)          *
*                2 - ARIA                                (26)          *
*                3 - SiO2 aka PM                         (27)          *
*                4 - BC408 aka Pilot B                   (28)          *
*                5 - Polystyrene aka PS                  (29)          *
*                6 - PolyMethylMethacrylate aka PMMA     (30)          *
*                7 - Optical glue                        (31)          *
*                                                                      *
*----------------------------------------------------------------------*
*


c     Si inizializza ACT = 0 perchè il primo fotone è blu.
      ACT = 0

c     Lunghezza d'onda del blu (420nm) e del verde (480nm) in cm.
      WLGB = 4.2E-5
      WLGV = 4.8E-5

c     Energia fotone del fotone blu e verde.
c     Calcolo automatico: wavelength --> GeV
c     E[J]=(h[J*s]*c[cm/s])/lamda[cm]
c     1[eV]=1.60217653D-19[J]
c     1[eV]=1.0D-09[GeV]
      ENERB = (1.240700167D-13)/WLGB
      ENERV = (1.240700167D-13)/WLGV
c      ENERB = 2.95404814523E-09
c      ENERV = 2.58479212708E-09


c     Variabile SORgente: 0 --> eventi localizzati (vedi sotto)
c                         1 --> eventi distribuiti random
      SOR = 0

c     Coordinate degli eventi localizzati ( SOR = 0 )
      XZER = 0.0001D+00
      YZER = 0.0D+00
      ZZER = 0.0D+00

c     Inizializzo la posizione del primo fotone.
      IF ( SOR .EQ. 0 ) THEN
         XFIB = XZER
         YFIB = YZER
         ZFIB = ZZER
      ELSEIF ( SOR .EQ. 1 ) THEN
         XFIB = -1.58D+00 + 3.16D+00 * FLRNDM(XDUMMY) 
         YFIB = -0.48D+00 + 0.96D+00 * FLRNDM(XDUMMY) 
         ZFIB = -1.58D+00 + 3.16D+00 * FLRNDM(XDUMMY)  
      ENDIF
      RFIB = 0


c     Indice di rifrazione blu.
      RFRB1 = 0.54105
      RFRB2 = 1.00028177
      RFRB3 = 1.5554
      RFRB4 = 1.52
      RFRB5 = 1.6171
      RFRB6 = 1.5025
      RFRB7 = 1.5754
 
c     Indice di rifrazione verde.
      RFRV1 = 0.73927
      RFRV2 = 1.00027954
      RFRV3 = 1.5501
      RFRV4 = RFRB4
      RFRV5 = 1.60667
      RFRV6 = 1.49766
      RFRV7 = 1.5691

c     Riflettività blu/verde già espressa come 1-R.
c     NON USATI: IMPOSTATI DA SCHEDA FLAIR
      RFL1 = 0.07668
      RFL2 = 0.
      RFL3 = 0.9952762
      RFL4 = 1.
      RFL5 = 0.944401
      RFL6 = 0.995968
      RFL7 = ONEONE
 
c     Coeff. assorbimento blu in cm-1.
      ABSB1 = 1.5212E+6
      ABSB2 = 0.000106
      ABSB3 = 0.3
      ABSB4 = 0.0035
c      ABSB5 = 18.0
c      ABSB5 = 15.0
c      ABSB5 = 12.0
c      ABSB5 = 10.0
      ABSB5 = 8.0
c      ABSB5 = 5.0
c      ABSB5 = 2.0
c      ABSB5 = 1.0
c      ABSB5 = 0.5
c      ABSB5 = 0.2
c      ABSB5 = 0.1
c      ABSB5 = 0.00548941798941
      ABSB6 = 0.277938696464
      ABSB7 = 3.26575956162
 
c     Coeff. assorbimento verde in cm-1.
      ABSV1 = 1.5223E+6
      ABSV2 = ABSB2
      ABSV3 = 0.2
      ABSV4 = ABSB4
      ABSV5 = 0.00285714285714
      ABSV6 = ABSB6
      ABSV7 = 1.6162165854
 
c     Coeff. diffusione blu in cm-1.
      DFFB1 = ZERZER
      DFFB2 = ZERZER
      DFFB3 = ZERZER
      DFFB4 = ZERZER
      DFFB5 = ZERZER
      DFFB6 = ZERZER
      DFFB7 = ZERZER
 
c     Coeff. diffusione verde in cm-1.
      DFFV1 = DFFB1
      DFFV2 = DFFB2
      DFFV3 = DFFB3
      DFFV4 = DFFB4
      DFFV5 = DFFB5
      DFFV6 = DFFB6
      DFFV7 = DFFB7   
 
c     Rugosità blu/verde.
      ROU1 = ZERZER
      ROU2 = ZERZER
      ROU3 = ZERZER
      ROU4 = ZERZER
      ROU5 = ZERZER
      ROU6 = ZERZER
      ROU7 = ZERZER
 
c     Contatori fotoni generati blu/verdi.
      CFOTB = 0
      CFOTV = 0
 
c     Contatori fotoni blu depositati nel PS, nel PMMA e nell'AL.
      CPS = 0
      CPMMA = 0
      CAL = 0 

c     Contatori BDX dei fotoni verdi verso il PM (totale, delle
c     sole fibre orizzonrali e di quelle verticali).
      CPM = 0
      CPMO = 0
      CPMV = 0

c     Contatori BDX dei fotoni verdi verso il PM (dal caldding e
c     dal core) e verso l'aria dalle fibre.
      CCLPM = 0
      CCOPM = 0
      CFIBAI = 0

c     Contatori BDX core/pm.
      PMO1 = 0
      PMO2 = 0
      PMO3 = 0
      PMO4 = 0
      PMO5 = 0
      PMO6 = 0
      PMO7 = 0
      PMO8 = 0
      PMO9 = 0
      PMO10 = 0
      PMO11 = 0
      PMO12 = 0
      PMO13 = 0
      PMO14 = 0
      PMO15 = 0
      PMO16 = 0
      PMO17 = 0
      PMO18 = 0
      PMO19 = 0
      PMO20 = 0
      PMO21 = 0
      PMO22 = 0
      PMO23 = 0
      PMO24 = 0
      PMO25 = 0
      PMO26 = 0
      PMO27 = 0
      PMO28 = 0
      PMO29 = 0
      PMO30 = 0
      PMO31 = 0
      PMO32 = 0
      PMV1 = 0
      PMV2 = 0
      PMV3 = 0
      PMV4 = 0
      PMV5 = 0
      PMV6 = 0
      PMV7 = 0
      PMV8 = 0
      PMV9 = 0
      PMV10 = 0
      PMV11 = 0
      PMV12 = 0
      PMV13 = 0
      PMV14 = 0
      PMV15 = 0
      PMV16 = 0
      PMV17 = 0
      PMV18 = 0
      PMV19 = 0
      PMV20 = 0
      PMV21 = 0
      PMV22 = 0
      PMV23 = 0
      PMV24 = 0
      PMV25 = 0
      PMV26 = 0
      PMV27 = 0
      PMV28 = 0
      PMV29 = 0
      PMV30 = 0
      PMV31 = 0
      PMV32 = 0


      RETURN
*=== End of subroutine Usrini =========================================*
      END

